package xyz.brassgoggledcoders.boilerplate.mod.items;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.world.World;
import xyz.brassgoggledcoders.boilerplate.api.IDebuggable;
import xyz.brassgoggledcoders.boilerplate.lib.common.items.ItemBase;
import xyz.brassgoggledcoders.boilerplate.mod.Boilerplate;

import java.util.Iterator;
import java.util.LinkedHashMap;

/**
 * @author SkySom
 */
public class ItemDebuggerStick extends ItemBase
{
	public ItemDebuggerStick()
	{
		super("debugger_stick");
		this.func_77637_a(CreativeTabs.field_78026_f);
	}

	@Override
	public ItemStack func_77659_a(ItemStack itemStack, World world, EntityPlayer entityPlayer)
	{
		MovingObjectPosition rayTrace = this.func_77621_a(world, entityPlayer, true);
		IDebuggable debuggable = null;
		if(rayTrace != null && rayTrace.field_72313_a != null)
		{
			if (rayTrace.field_72313_a == MovingObjectPosition.MovingObjectType.BLOCK)
			{
				TileEntity tileEntity = world.func_175625_s(rayTrace.func_178782_a());
				{
					if (tileEntity instanceof IDebuggable)
					{
						debuggable = (IDebuggable)tileEntity;
					}
				}
			}
			else if (rayTrace.field_72313_a == MovingObjectPosition.MovingObjectType.ENTITY)
			{
				Entity entity = rayTrace.field_72308_g;
				if (entity instanceof IDebuggable)
				{
					debuggable = (IDebuggable)entity;
				}
			}
		}

		if (debuggable != null)
		{
			LinkedHashMap<String, String> debugStrings = debuggable.getDebugStrings();
			if(debugStrings != null && !debugStrings.isEmpty())
			{
				Iterator<String> iterator = debugStrings.values().iterator();
				while(iterator.hasNext())
				{
					Boilerplate.logger.info(iterator.next());
				}
			}

		}

		return itemStack;
	}
}
